package com.gingersoft.gsa.cloud.main.mvp.model;

import android.app.Application;

import com.gingersoft.gsa.cloud.main.mvp.contract.SalesContract;
import com.gingersoft.gsa.cloud.main.mvp.model.bean.DeliveryLineChartBean;
import com.gingersoft.gsa.cloud.main.mvp.model.bean.DeliveryPersonnelReportBean;
import com.gingersoft.gsa.cloud.main.mvp.model.bean.SalesFoodsBean;
import com.gingersoft.gsa.cloud.main.mvp.model.service.MainReportService;
import com.google.gson.Gson;
import com.jess.arms.di.scope.FragmentScope;
import com.jess.arms.integration.IRepositoryManager;
import com.jess.arms.mvp.BaseModel;

import java.util.Map;

import javax.inject.Inject;

import io.reactivex.Observable;
import okhttp3.RequestBody;


/**
 * ================================================
 * Description:
 * <p>
 * Created by MVPArmsTemplate on 02/23/2020 16:21
 * <a href="mailto:jess.yan.effort@gmail.com">Contact me</a>
 * <a href="https://github.com/JessYanCoding">Follow me</a>
 * <a href="https://github.com/JessYanCoding/MVPArms">Star me</a>
 * <a href="https://github.com/JessYanCoding/MVPArms/wiki">See me</a>
 * <a href="https://github.com/JessYanCoding/MVPArmsTemplate">模版请保持更新</a>
 * ================================================
 */
@FragmentScope
public class SalesModel extends BaseModel implements SalesContract.Model {
    @Inject
    Gson mGson;
    @Inject
    Application mApplication;

    @Inject
    public SalesModel(IRepositoryManager repositoryManager) {
        super(repositoryManager);
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        this.mGson = null;
        this.mApplication = null;
    }

    @Override
    public Observable<SalesFoodsBean> getSalesReportInfo(Map<String, Object> map) {
        return mRepositoryManager.obtainRetrofitService(MainReportService.class)
                .getSalesReportInfo(map);
    }

    @Override
    public Observable<SalesFoodsBean> getSalesReportInfo(RequestBody requestBody) {
        return mRepositoryManager.obtainRetrofitService(MainReportService.class)
                .getSalesReportInfo(requestBody);
    }

    @Override
    public Observable<DeliveryLineChartBean> getDeliveryOrderCurveInfo(Map<String, Object> map) {
        return mRepositoryManager.obtainRetrofitService(MainReportService.class)
                .getDeliveryOrderCurveInfo(map);
    }

    @Override
    public Observable<DeliveryPersonnelReportBean> getDeliveryPersonnelReport(Map<String, Object> map) {
        return mRepositoryManager.obtainRetrofitService(MainReportService.class)
                .getDeliveryPersonnelReport(map);
    }
}